//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////

#define  _MDRV_COMMON_VR_C_

#ifdef MSOS_TYPE_LINUX
#include <pthread.h>
#endif
#if !defined(MSOS_TYPE_LINUX_KERNEL)
#include "string.h"
#else
#include <linux/string.h>
#endif

#if (defined MSOS_TYPE_LINUX) || (defined ANDROID)
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h> // O_RDWR
#endif

#include "MsCommon.h"
#include "MsOS.h"
#include "MsTypes.h"

#ifdef STELLAR
#include "../xc/mdrv_xc_io.h"
#include "../xc/mdrv_xc_st.h"
#else
#include "mdrv_xc_io.h"
#include "mdrv_xc_st.h"
#endif

#define BYTE                MS_U8
#define WORD                MS_U16
#define DWORD               MS_U32

#ifndef UNUSED
#define UNUSED(x) (void)(x)
#endif

#ifdef MSOS_TYPE_LINUX
static MS_S32 _s32FdCOM = -1;
#endif
#ifdef MSOS_TYPE_LINUX_KERNEL
extern void MDrv_XC_VR_W2BYTE(MS_U32 u32Reg, MS_U16 u16Val);
extern WORD MDrv_XC_VR_R2BYTE(MS_U32 u32Reg);
extern BYTE MDrv_XC_VR_ReadByte(MS_U32 u32Reg);
extern WORD MDrv_XC_VR_R2BYTEMSK(MS_U32 u32Reg, MS_U16 u16Mask);
extern void MDrv_XC_VR_WriteByte(MS_U32 u32Reg, MS_U8 u8Val);
extern void MDrv_XC_VR_W2BYTEMSK(MS_U32 u32Reg, MS_U16 u16Val, MS_U16 u16Mask);
#endif

void MDrv_COMM_VR_W2BYTE(MS_U32 u32Reg, MS_U16 u16Val)
{
#if (defined MSOS_TYPE_LINUX) || (defined ANDROID)
    ST_KDRV_XC_VR_W2BYTE stReg;
    stReg.u32Reg = u32Reg;
    stReg.u16Val = u16Val;
    if(0 > _s32FdCOM)
    {
        _s32FdCOM = open("/dev/scaler", O_RDWR);

        if(0 > _s32FdCOM)
        {
            printf("Scaler device not opened!!!!\n");
        }
    }
    if (ioctl(_s32FdCOM, MDRV_XC_IOC_VR_W2BYTE, &stReg))
    {
        printf("MDrv_COMMON_VR_W2BYTE send MDRV_XC_IOC_VR_W2BYTE fail!!!!\n");
    }
#elif defined(MSOS_TYPE_LINUX_KERNEL)
    MDrv_XC_VR_W2BYTE(u32Reg, u16Val);
#else
    UNUSED(u32Reg);
    UNUSED(u16Val);
#endif
}

MS_U16 MDrv_COMM_VR_R2BYTE(MS_U32 u32Reg)
{
    MS_U16 u16Ret = 0;
#if (defined MSOS_TYPE_LINUX) || (defined ANDROID)
    ST_KDRV_XC_VR_R2BYTE stReg;
    stReg.u32Reg = u32Reg;
    if(0 > _s32FdCOM)
    {
        _s32FdCOM = open("/dev/scaler", O_RDWR);

        if(0 > _s32FdCOM)
        {
            printf("Scaler device not opened!!!!\n");
        }
    }
    if (ioctl(_s32FdCOM, MDRV_XC_IOC_VR_R2BYTE, &stReg))
    {
        printf("MDrv_COMMON_VR_R2BYTE send MDRV_XC_IOC_VR_R2BYTE fail!!!!\n");
        return u16Ret;
    }
    u16Ret = stReg.u16Val;
#elif defined(MSOS_TYPE_LINUX_KERNEL)
    u16Ret = MDrv_XC_VR_R2BYTE(u32Reg);
#else
    UNUSED(u32Reg);
#endif

    return u16Ret;
}

MS_U8 MDrv_COMM_VR_RBYTE(MS_U32 u32Reg)
{
    MS_U8 u8Ret = 0;
#if (defined MSOS_TYPE_LINUX) || (defined ANDROID)
    ST_KDRV_XC_VR_READBYTE stReg;
    stReg.u32Reg = u32Reg;
    if(0 > _s32FdCOM)
    {
        _s32FdCOM = open("/dev/scaler", O_RDWR);

        if(0 > _s32FdCOM)
        {
            printf("Scaler device not opened!!!!\n");
        }
    }
    if (ioctl(_s32FdCOM, MDRV_XC_IOC_VR_R2BYTE, &stReg))
    {
        printf("MDrv_COMMON_VR_R2BYTE send MDRV_XC_IOC_VR_R2BYTE fail!!!!\n");
        return u8Ret;
    }
    u8Ret = stReg.u8Val;
#elif defined(MSOS_TYPE_LINUX_KERNEL)
    u8Ret = MDrv_XC_VR_ReadByte(u32Reg);
#else
    UNUSED(u32Reg);
#endif

    return u8Ret;
}

MS_U16 MDrv_COMM_VR_R2BYTEMSK(MS_U32 u32Reg, MS_U16 u16Mask)
{
    MS_U16 u16Ret = 0;
#if (defined MSOS_TYPE_LINUX) || (defined ANDROID)
    ST_KDRV_XC_VR_R2BYTEMASK stReg;
    stReg.u32Reg  = u32Reg;
    stReg.u16Mask = u16Mask;
    if(0 > _s32FdCOM)
    {
        _s32FdCOM = open("/dev/scaler", O_RDWR);

        if(0 > _s32FdCOM)
        {
            printf("Scaler device not opened!!!!\n");
        }
    }
    if (ioctl(_s32FdCOM, MDRV_XC_IOC_VR_R2BYTEMASK, &stReg))
    {
        printf("MDrv_COMMON_VR_R2BYTEMSK send MDRV_XC_IOC_VR_R2BYTEMASK fail!!!!\n");
        return u16Ret;
    }
    u16Ret = stReg.u16Val;
#elif defined(MSOS_TYPE_LINUX_KERNEL)
    u16Ret = MDrv_XC_VR_R2BYTEMSK(u32Reg, u16Mask);
#else
    UNUSED(u32Reg);
    UNUSED(u16Mask);
#endif

    return u16Ret;
}

void MDrv_COMM_VR_WBYTE(MS_U32 u32Reg, MS_U8 u8Val)
{
#if (defined MSOS_TYPE_LINUX) || (defined ANDROID)
    ST_KDRV_XC_VR_WRITEBYTE stReg;
    stReg.u32Reg = u32Reg;
    stReg.u8Val  = u8Val;
    if(0 > _s32FdCOM)
    {
        _s32FdCOM = open("/dev/scaler", O_RDWR);

        if(0 > _s32FdCOM)
        {
            printf("Scaler device not opened!!!!\n");
        }
    }
    if (ioctl(_s32FdCOM, MDRV_XC_IOC_VR_WRITEBYTE, &stReg))
    {
        printf("MDrv_COMMON_VR_WriteByte send MDRV_XC_IOC_VR_WRITEBYTE fail!!!!\n");
    }
#elif defined(MSOS_TYPE_LINUX_KERNEL)
    MDrv_XC_VR_WriteByte(u32Reg, u8Val);
#else
    UNUSED(u32Reg);
    UNUSED(u8Val);
#endif
}

void MDrv_COMM_VR_W2BYTEMSK(MS_U32 u32Reg, MS_U16 u16Val, MS_U16 u16Mask)
{
#if (defined MSOS_TYPE_LINUX) || (defined ANDROID)
    ST_KDRV_XC_VR_W2BYTEMASK stReg;
    stReg.u32Reg  = u32Reg;
    stReg.u16Mask = u16Mask;
    stReg.u16Val  = u16Val;
    if(0 > _s32FdCOM)
    {
        _s32FdCOM = open("/dev/scaler", O_RDWR);

        if(0 > _s32FdCOM)
        {
            printf("Scaler device not opened!!!!\n");
        }
    }
    if (ioctl(_s32FdCOM, MDRV_XC_IOC_VR_W2BYTEMASK, &stReg))
    {
        printf("MDrv_COMMON_VR_W2BYTEMSK send MDRV_XC_IOC_VR_W2BYTEMASK fail!!!!\n");
    }
#elif defined(MSOS_TYPE_LINUX_KERNEL)
    MDrv_XC_VR_W2BYTEMSK(u32Reg, u16Val, u16Mask);
#else
    UNUSED(u32Reg);
    UNUSED(u16Mask);
    UNUSED(u16Val);
#endif
}
